﻿using System;
using System.Net;
using System.Net.Sockets;
using DIMENSION4_OTW_FORMAT;

namespace DIMENSION4_OTW_CLIENT
{
    class Program
    {
        static void Main(string[] args)
        {
            IPAddress address;
            int port;
            try
            {
                address = IPAddress.Parse(args[0]);
                port = int.Parse(args[1]);
            }
            catch (Exception)
            {
                Console.WriteLine("usage: DIMENSION4_OTW_CLIENT <ip address> <port>");
                Console.WriteLine("   Listen on <ip address>:<port> for OTW packets");
                Console.WriteLine("   and decode them and print them to the console");
                return;
            }

            Message message = new Message();

            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            IPEndPoint localEP = new IPEndPoint(address, port);
            socket.Bind(localEP);
            socket.Blocking = true;
            while (true)
            {
                byte[] buffer = new byte[message.Size];
                if (socket.Receive(buffer) == message.Size)
                {
                    message.Decode(buffer);
                    message.Print();
                }
            }
        }
    }
}
