﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using DIMENSION4_OTW_FORMAT;

namespace DIMENSION4_OTW_SENDER
{
    class Program
    {
        static void Main(string[] args)
        {
            IPAddress address;
            int port;
            try
            {
                address = IPAddress.Parse(args[0]);
                port = int.Parse(args[1]);
            }
            catch (Exception)
            {
                Console.WriteLine("usage: DIMENSION4_OTW_SENDER <ip address> <port>");
                Console.WriteLine("   Send to <ip address>:<port> a test OTW packet");
                return;
            }

            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            IPEndPoint localEP = new IPEndPoint(IPAddress.Any, 0);
            IPEndPoint remoteEP = new IPEndPoint(address, port);
            socket.Bind(localEP);
            
            while (true)
            {
                Message message = new Message(0x0011CE0011223344, 10.0f, 20.0f, 30.0f, 0.5f);
                byte[] buffer = message.Encode();
                socket.SendTo(buffer, remoteEP);
                Thread.Sleep(100);
            }
        }
    }
}
